import os
import sys
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"ArnoldNode",
				"ArnoldShader",
				"ShaderVariablesArnold",
				"arnold.pmh",
				"arnoldDL" ]

	dll = module.DLL( "fexArnoldDL", srcList )

	module.includemap = {}
	module.includemap['arnold'] = forge.arnold_include

	dll.linkmap = {}
	dll.linkmap['arnold'] = "-Xlinker -rpath='" + forge.arnold_lib + "'"
	dll.linkmap['arnold'] = '-L' + forge.arnold_lib + ' -lai'

	deplibs = forge.corelibs+ [
				"fexSurfaceDLLib",
				"fexTerminalDLLib"	]

	forge.deps( ["fexArnoldDLLib"], deplibs )

	arnoldPath = os.path.join(forge.libPath, 'arnold')
	if os.path.isdir(arnoldPath) == 0:
		os.makedirs(arnoldPath, 0755)

	dest = os.path.join(arnoldPath, 'libfexArnoldDL.so')
	if os.path.lexists(dest) == 0:
		os.symlink("../libfexArnoldDL.so", dest)


def auto(module):
	if forge.arnold_include == '' or forge.arnold_lib == '':
		return 'unset'

	test_file = """
#include "ai.h"

int main(void)
{
	return(0);
}
    \n"""

	forge.includemap['arnold'] = forge.arnold_include

#	forge.linkmap['arnold'] = "-Xlinker -rpath='" + forge.arnold_lib + "'"
#	forge.linkmap['arnold'] = '-L' + forge.arnold_lib + ' -lai'

	result = forge.cctest(test_file)

	forge.includemap['arnold'] = ''
	forge.linkmap['arnold'] = ''

	return result
