import sys
forge = sys.modules["forge"]

def setup(module):
	srcList = [ "SurfaceAccessibleOsd",
				"SurfaceAccessorOsd",
				"opensubdiv.pmh",
				"opensubdivDL" ]

	dll = module.DLL( "fexOpenSubdivDL", srcList )

	module.includemap = {}
	module.includemap['opensubdiv'] = forge.opensubdiv_include

	dll.linkmap = {}
	dll.linkmap['opensubdiv'] = "-Xlinker -rpath='" + forge.opensubdiv_lib + "'"
	dll.linkmap['opensubdiv'] += ' -L' + forge.opensubdiv_lib + ' -losdCPU'

	deplibs = forge.corelibs+ [
				"fexSurfaceDLLib" ]

	forge.deps( ["fexOpenSubdivDLLib"], deplibs )

def auto(module):
	test_file = """
#include <opensubdiv/far/topologyDescriptor.h>

int main(void)
{
	return(0);
}
    \n"""

	# TODO also configurable (as above)
	forge.includemap['opensubdiv'] = forge.opensubdiv_include

	result = forge.cctest(test_file)

	forge.includemap['opensubdiv'] = ''

	return result
