import sys
import re
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"SurfaceAccessibleXGen",
				"xgen.pmh",
				"xgenDL" ]

	dll = module.DLL( "fexXGenDL", srcList )

	# NOTE Maya 2016 has broken XpdFile.h (no such xpd/Xpd.h)

	# TODO multiple versions
	maya_message = "/"
	maya_root = "/usr/autodesk/maya"
	maya_source_count = len(forge.maya_sources)
	maya_source_index = maya_source_count - 1
	while maya_source_index >= 0:
		maya_version = forge.maya_sources[maya_source_index][0]
		if not re.match("2016", maya_version):
			maya_message = maya_version
			break
		maya_source_index = maya_source_index - 1
	if maya_source_index >= 0:
		maya_root = forge.maya_sources[maya_source_index][1] + "/.."

	sys.stdout.write(" " + maya_message)

	module.includemap = {}
	module.includemap['maya'] = maya_root + '/include'
	module.includemap['xgen'] = maya_root + '/plug-ins/xgen/include'
	module.includemap['xgen2'] = maya_root + '/plug-ins/xgen/include/xgen'
	module.includemap['xgen3'] = maya_root + '/plug-ins/xgen/include/XGen'

	dll.linkmap = {}
	dll.linkmap['xgen'] = '-L' + maya_root + '/plug-ins/xgen/lib'
	dll.linkmap['xgen'] += ' -lAdskXGen'

	deplibs = forge.corelibs+ [
				"fexSurfaceDLLib" ]

	forge.deps( ["fexXGenDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",		"fexXGenDL",	None,		None) ]

	module.Module('test')
